<script setup>
definePageMeta({
    layout: 'detail',
    name: 'Mode carte',
});

import { useRouter } from "#app";
import L from "leaflet";
import "leaflet.markercluster";
import { computed, createApp, ref, watch } from "vue";
import MapTooltip from "~/components/map/tooltip.vue";

const { data } = await useEventsApi();
const events = computed(() => data.value.filter(event => event.location.latitude && event.location.longitude));

const mapRef = ref(null);
const map = ref(null);
const markerClusterGroup = ref(null);

const markerIcons = computed(() => {
    const isLargeScreen = window?.innerWidth > 430;
    return {
        orange: { size: isLargeScreen ? [66, 83] : [36, 48], anchor: isLargeScreen ? [33, 83] : [19, 48] },
        pink: { size: isLargeScreen ? [43, 53] : [23, 31], anchor: isLargeScreen ? [21, 53] : [11, 30] },
    };
});

const createIcon = (color) =>
    L.icon({
        iconUrl: `/images/${color}_map_marker.svg`,
        iconSize: markerIcons.value[color].size,
        iconAnchor: markerIcons.value[color].anchor,
    });

const router = useRouter();

const getMarker = (event) => {
    const marker = L.marker([event.location.latitude, event.location.longitude], { icon: createIcon("pink") });

    marker.on("popupopen", () => marker.setIcon(createIcon("orange")));
    marker.on("popupclose", () => marker.setIcon(createIcon("pink")));

    const container = document.createElement("div");
    createApp(MapTooltip, { event, onClose: () => marker.closePopup() }).use(router).mount(container);

    marker.bindPopup(container, { interactive: true, closeButton: false, offset: [-120, 125] });
    return marker;
};

const updateCluster = (currentEvents) => {
    if (!map.value || !markerClusterGroup.value) return;

    const currentCluster = toRaw(markerClusterGroup.value);
    currentCluster.clearLayers();

    if (currentEvents.length) {
        currentEvents.forEach(event => {
            if (event.location.latitude && event.location.longitude) {
                currentCluster.addLayer(getMarker(event));
            }
        });

        const clusterBounds = currentCluster.getBounds();
        if (clusterBounds.isValid()) {
            map.value.fitBounds(clusterBounds, { padding: [10, 10] });
        }
    }
};

const onMapReady = () => {
    map.value = mapRef.value.leafletObject;
    markerClusterGroup.value = L.markerClusterGroup();
    map.value.addLayer(markerClusterGroup.value);
    updateCluster(events.value);
};

const hasNoEvent = computed(() => events.value && events.value.length === 0);

watch(events, updateCluster, { immediate: true });

</script>


<template>
    <div class="w-full h-full mx-auto">
        <SectionTitle :title="'Mode Carte'" hx="h1" />
        <div class="flex flex-row flex-wrap gap-5 justify-center">
            <Menu :current_mode="'map'" />
            <div class="w-full max-w-6xl h-auto min-h-[40vh]">
                <ClientOnly>
                    <p class="text-center text-xl text-red-500" v-if="hasNoEvent">Pas d'évènements à afficher.</p>
                    <div class="h-[70vh] w-full" :class="{ 'brightness-50': hasNoEvent }">
                        <LMap :options="{ zoomControl: false, zoomAnimation: false }" :zoom="5"
                            :center="[47.21322, -1.559482]" :use-global-leaflet="true" ref="mapRef" @ready="onMapReady">
                            <LControlZoom position="topright" zoom-in-text="" zoom-out-text="" />
                            <LTileLayer url="https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png" layer-type="base" />
                            <img src="/images/traveler.svg"
                                class="absolute h-[153px] xl:h-[274px] right-[2%] bottom-[2%] z-[400] hidden 2xl:block" />
                        </LMap>
                    </div>
                </ClientOnly>

            </div>

        </div>
    </div>
</template>

<style>
.leaflet-popup-content-wrapper {
    padding: 0px;
    border: none;
    background-color: transparent;
    box-shadow: none;
}

.leaflet-popup-tip {
    display: none;
}

.leaflet-container {
    font-family: inherit;
}

.leaflet-touch .leaflet-bar a {
    width: 34px;
    height: 34px;
}

.leaflet-control-zoom-in {
    background-image: url("/images/zoom_in.svg");
}

.leaflet-control-zoom-out {
    background-image: url("/images/zoom_out.svg");
}
</style>